"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));
var React = _interopRequireWildcard(require("react"));
var _react2 = require("@testing-library/react");
require("@testing-library/jest-dom");
var _ = require(".");
var _jsxFileName = "/home/builduser/work/cd8b79cf755711f/packages/wix-ui-test-utils/dist/cjs/react-helpers/helpers.spec.tsx";
function _interopRequireWildcard(e, t) { if ("function" == typeof WeakMap) var r = new WeakMap(), n = new WeakMap(); return (_interopRequireWildcard = function (e, t) { if (!t && e && e.__esModule) return e; var o, i, f = { __proto__: null, default: e }; if (null === e || "object" != typeof e && "function" != typeof e) return f; if (o = t ? n : r) { if (o.has(e)) return o.get(e); o.set(e, f); } for (const t in e) "default" !== t && {}.hasOwnProperty.call(e, t) && ((i = (o = Object.defineProperty) && Object.getOwnPropertyDescriptor(e, t)) && (i.get || i.set) ? o(f, t, i) : f[t] = e[t]); return f; })(e, t); }
describe('helpers', () => {
  describe('isClassExists function', () => {
    const classes = 'class class2 class3';
    const element = document.createElement('div');
    element.className = classes;
    describe('existing class', () => {
      classes.split(' ').forEach(className => it(`should return true for className ${className}`, () => {
        expect((0, _.isClassExists)(element, className)).toBe(true);
      }));
    });
    describe('none existing classes', () => {
      [undefined, 'cla', 'class4'].forEach(className => it(`should return false for className ${className}`, () => {
        expect((0, _.isClassExists)(element, className)).toBe(false);
      }));
    });
  });
  describe('sleep helper', () => {
    it('sleeps', async () => {
      const previousTime = Date.now();
      await (0, _.sleep)(50);
      expect(Date.now()).toBeGreaterThanOrEqual(previousTime + 50);
    });
  });
  describe('makeControlled function', () => {
    const UncontrolledInput = props => /*#__PURE__*/React.createElement("input", (0, _extends2.default)({}, props, {
      __self: void 0,
      __source: {
        fileName: _jsxFileName,
        lineNumber: 40,
        columnNumber: 10
      }
    }));
    it('should init uncontrolled component with initial value', () => {
      const ControlledInput = (0, _.makeControlled)(UncontrolledInput);
      const initialValue = 'some value';
      (0, _react2.render)(/*#__PURE__*/React.createElement(ControlledInput, {
        value: initialValue,
        __self: void 0,
        __source: {
          fileName: _jsxFileName,
          lineNumber: 46,
          columnNumber: 14
        }
      }));
      const inputElement = _react2.screen.getByRole('textbox');
      expect(inputElement).toHaveValue(initialValue);
    });
    it('should invoke onChange callback', () => {
      const onChange = jest.fn();
      const ControlledInput = (0, _.makeControlled)(UncontrolledInput);
      (0, _react2.render)(/*#__PURE__*/React.createElement(ControlledInput, {
        onChange: onChange,
        __self: void 0,
        __source: {
          fileName: _jsxFileName,
          lineNumber: 56,
          columnNumber: 14
        }
      }));
      const enteredValue = 'some value';
      const input = _react2.screen.getByRole('textbox');
      _react2.fireEvent.change(input, {
        target: {
          value: enteredValue
        }
      });
      expect(onChange).toHaveBeenCalledTimes(1);
      expect(onChange.mock.calls[0][0].target.value).toBe(enteredValue);
      expect(input).toHaveValue(enteredValue);
    });
    it('should bind passed prop-functions to *this*', () => {
      const NotifyOnEnter = ({
        onEnter,
        ...passedProps
      }) => /*#__PURE__*/React.createElement(UncontrolledInput, (0, _extends2.default)({}, passedProps, {
        onKeyDown: e => e.key === 'Enter' && onEnter(),
        __self: void 0,
        __source: {
          fileName: _jsxFileName,
          lineNumber: 73,
          columnNumber: 9
        }
      }));
      const ControlledInput = (0, _.makeControlled)(NotifyOnEnter);
      (0, _react2.render)(/*#__PURE__*/React.createElement(ControlledInput, {
        value: "some value",
        onEnter: function () {
          // NOTE: don't use arrow functions by purpose
          this.setState({
            value: ''
          });
        },
        __self: void 0,
        __source: {
          fileName: _jsxFileName,
          lineNumber: 84,
          columnNumber: 9
        }
      }));
      const input = _react2.screen.getByRole('textbox');
      _react2.fireEvent.keyDown(input, {
        key: 'Enter'
      });
      expect(input).toHaveValue('');
    });
  });
});
//# sourceMappingURL=helpers.spec.js.map