"use strict";

exports.__esModule = true;
exports.testkitFactoryCreator = testkitFactoryCreator;
exports.uniTestkitFactoryCreator = uniTestkitFactoryCreator;
var _react = require("@testing-library/react");
var _unidriverJsdomReact = require("@wix/unidriver-jsdom-react");
const getElement = ({
  wrapper,
  dataHook
}) => {
  return wrapper.querySelector(`[data-hook='${dataHook}']`);
};
function testkitFactoryCreator(driverFactory) {
  return testkitArgs => driverFactory({
    element: getElement(testkitArgs),
    wrapper: testkitArgs.wrapper,
    eventTrigger: _react.fireEvent,
    dataHook: testkitArgs.dataHook
  });
}
function uniTestkitFactoryCreator(driverFactory) {
  return testkitArgs => {
    const element = getElement(testkitArgs);
    return driverFactory((0, _unidriverJsdomReact.jsdomReactUniDriver)(element), (0, _unidriverJsdomReact.jsdomReactUniDriver)(document.body), {
      dataHook: testkitArgs.dataHook
    });
  };
}
//# sourceMappingURL=index.js.map