import * as React from 'react';
import { createRoot } from 'react-dom/client';
import { reactEventTrigger } from '../react-helpers';
function componentFactory(Component) {
    let element;
    const eventTrigger = reactEventTrigger();
    const wrapperDiv = document.createElement('div');
    const root = createRoot(wrapperDiv);
    root.render(React.createElement("div", { ref: (r) => (element = r) }, Component));
    return {
        element: element && element.childNodes[0],
        wrapper: wrapperDiv,
        component: Component,
        eventTrigger,
    };
}
export function createDriverFactory(driverFactory) {
    return (Component) => driverFactory(componentFactory(Component));
}
//# sourceMappingURL=createDriverFactory.js.map