import { fireEvent } from '@testing-library/react';
import { jsdomReactUniDriver } from '@wix/unidriver-jsdom-react';
const getElement = ({ wrapper, dataHook }) => {
    return wrapper.querySelector(`[data-hook='${dataHook}']`);
};
export function testkitFactoryCreator(driverFactory) {
    return (testkitArgs) => driverFactory({
        element: getElement(testkitArgs),
        wrapper: testkitArgs.wrapper,
        eventTrigger: fireEvent,
        dataHook: testkitArgs.dataHook,
    });
}
export function uniTestkitFactoryCreator(driverFactory) {
    return (testkitArgs) => {
        const element = getElement(testkitArgs);
        return driverFactory(jsdomReactUniDriver(element), jsdomReactUniDriver(document.body), { dataHook: testkitArgs.dataHook });
    };
}
//# sourceMappingURL=index.js.map