import { fireEvent } from '@testing-library/react';
import { UniDriver } from '@wix/unidriver-core';
import { BaseDriver } from '../driver-factory';
import { BaseUniDriver } from '../base-driver';
export interface TestkitArgs {
    wrapper: Element;
    dataHook: string;
}
export type TestkitOutputRegular<T extends BaseDriver> = (data: {
    element: Element | undefined;
    wrapper: Element;
    eventTrigger: typeof fireEvent;
    dataHook: string;
}) => T;
export type TestkitOutputUni<T extends BaseUniDriver> = (base: UniDriver, body: UniDriver, options: {
    dataHook: string;
}) => T;
export declare function testkitFactoryCreator<T extends BaseDriver>(driverFactory: TestkitOutputRegular<T>): (testkitArgs: TestkitArgs) => T;
export declare function uniTestkitFactoryCreator<T extends BaseUniDriver>(driverFactory: TestkitOutputUni<T>): (testkitArgs: TestkitArgs) => T;
//# sourceMappingURL=index.d.ts.map