import { UniDriver } from '@wix/unidriver-core';
type StateValue = boolean | number | string;
interface StateMap {
    [stateName: string]: StateValue;
}
interface CompatStylesheet {
    $cssStates(states?: StateMap | null): {
        className: string;
    };
}
interface LegacyStylesheet {
    $cssStates(states?: StateMap | null): StateMap;
}
interface StylesheetV2 {
    cssStates(states?: StateMap | null): string;
}
type CommonStylesheet = LegacyStylesheet | CompatStylesheet | StylesheetV2;
/**
 * LEGACY SUPPORT
 */
export declare class StylableUnidriverUtilLegacy {
    private style;
    constructor(style: LegacyStylesheet);
    hasStyleState(base: UniDriver, stateName: string, param?: StateValue): Promise<boolean>;
    /**
     * Get style state value
     *
     * @returns state or null if not found
     */
    getStyleState(base: UniDriver, stateName: string): Promise<string | null>;
    private getStateDataAttrKey;
}
export declare class StylableUnidriverUtilCompat {
    private style;
    constructor(style: CompatStylesheet);
    hasStyleState(base: UniDriver, stateName: string, param?: StateValue): Promise<boolean>;
    /**
     * Get style state value
     *
     * @returns state or null if not found
     */
    getStyleState(base: UniDriver, stateName: string): Promise<string | true | null>;
    getStateValueFromClassName(cls: string, baseState: string): string;
    private getBaseStateWithParam;
}
export declare class StylableCompatUniDriver {
    private style;
    private internal;
    constructor(style: CommonStylesheet);
    hasStyleState(base: UniDriver, stateName: string, param?: StateValue): Promise<boolean>;
    /**
     * Get style state value
     *
     * @returns state or null if not found
     */
    getStyleState(base: UniDriver, stateName: string): Promise<any>;
}
export {};
//# sourceMappingURL=stylable-unidriver-util-legacy.d.ts.map